/* Tabela FORNECEDOR: Fornecedor */
/* Descrio: A trigger insere registros na tabela ALTERAPARTSPED a partir de alteraes
na tabela FORNECEDOR */
/* Objetivo: Registrar as alteraes realizadas nos campos NMRAZSOCFORN, NRINSJURFORN, NRINSESTFORN, NRINSCSUFRAMAFO
da tabela FORNECEDOR, para serem utilizadas na gerao do registro 0175 do Sped Fiscal */


create or replace
TRIGGER ALTERA_FORNECEDOR_SPED
AFTER UPDATE
ON FORNECEDOR FOR EACH ROW
DECLARE  
  V_NRSEQALTPARTSPED NUMBER;
  V_DTOPER           DATE;
BEGIN
  IF UPDATING THEN 
    IF (((:OLD.NMRAZSOCFORN <> :NEW.NMRAZSOCFORN) OR (:NEW.NMRAZSOCFORN IS NULL)) AND (:OLD.NMRAZSOCFORN IS NOT NULL)) THEN
       BEGIN
            SELECT MAX(NRSEQALTPARTSPED)
              INTO V_NRSEQALTPARTSPED
              FROM ALTERAPARTSPED;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_NRSEQALTPARTSPED := 0; 
       END;
       V_NRSEQALTPARTSPED := NVL(V_NRSEQALTPARTSPED,0)+1;
       V_DTOPER := SYSDATE;

       BEGIN
            DELETE ALTERAPARTSPED
             WHERE CDCHAVE = 'F'||:OLD.CDFORNECED
               AND CDCAMPO = '03'
               AND DTALTERACAO < V_DTOPER;
       END;

       INSERT INTO ALTERAPARTSPED (NRSEQALTPARTSPED,CDCHAVE,CDCAMPO,DTALTERACAO,DSCONTEUDOANT)
            VALUES (LPAD(V_NRSEQALTPARTSPED,'10','0'),'F'||:OLD.CDFORNECED,'03',V_DTOPER,:OLD.NMRAZSOCFORN);
    END IF;

    IF (((:OLD.NRINSJURFORN <> :NEW.NRINSJURFORN) OR (:NEW.NRINSJURFORN IS NULL)) AND (:OLD.NRINSJURFORN IS NOT NULL)) THEN
       BEGIN
            SELECT MAX(NRSEQALTPARTSPED)
              INTO V_NRSEQALTPARTSPED
              FROM ALTERAPARTSPED;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_NRSEQALTPARTSPED := 0;
       END;

       V_NRSEQALTPARTSPED := NVL(V_NRSEQALTPARTSPED,0)+1;
       V_DTOPER := SYSDATE;

       BEGIN
            DELETE ALTERAPARTSPED
             WHERE CDCHAVE = 'F'||:OLD.CDFORNECED
               AND CDCAMPO = DECODE(:OLD.IDTPIJURFORN,'F','06','05')
               AND DTALTERACAO < V_DTOPER;
       END;

       INSERT INTO ALTERAPARTSPED (NRSEQALTPARTSPED,CDCHAVE,CDCAMPO,DTALTERACAO,DSCONTEUDOANT)
            VALUES (LPAD(V_NRSEQALTPARTSPED,'10','0'),'F'||:OLD.CDFORNECED,DECODE(:OLD.IDTPIJURFORN,'F','06','05'),V_DTOPER,:OLD.NRINSJURFORN);
    END IF;

    IF (((:OLD.NRINSESTFORN <> :NEW.NRINSESTFORN) OR (:NEW.NRINSESTFORN IS NULL)) AND (:OLD.NRINSESTFORN IS NOT NULL)) THEN
       BEGIN
            SELECT MAX(NRSEQALTPARTSPED)
              INTO V_NRSEQALTPARTSPED
              FROM ALTERAPARTSPED;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_NRSEQALTPARTSPED := 0; 
       END;
       
       V_NRSEQALTPARTSPED := NVL(V_NRSEQALTPARTSPED,0)+1;
       V_DTOPER := SYSDATE;

       BEGIN
            DELETE ALTERAPARTSPED
             WHERE CDCHAVE = 'F'||:OLD.CDFORNECED
               AND CDCAMPO = '07'
               AND DTALTERACAO < V_DTOPER;
       END;

       INSERT INTO ALTERAPARTSPED (NRSEQALTPARTSPED,CDCHAVE,CDCAMPO,DTALTERACAO,DSCONTEUDOANT) 
            VALUES (LPAD(V_NRSEQALTPARTSPED,'10','0'),'F'||:OLD.CDFORNECED,'07',V_DTOPER,:OLD.NRINSESTFORN);            
    END IF;
    
    IF (((:OLD.NRINSCSUFRAMAFO <> :NEW.NRINSCSUFRAMAFO) OR (:NEW.NRINSCSUFRAMAFO IS NULL)) AND (:OLD.NRINSCSUFRAMAFO IS NOT NULL)) THEN
       BEGIN
            SELECT MAX(NRSEQALTPARTSPED)
              INTO V_NRSEQALTPARTSPED
              FROM ALTERAPARTSPED;
       EXCEPTION
            WHEN NO_DATA_FOUND THEN
                 V_NRSEQALTPARTSPED := 0; 
       END;

       V_NRSEQALTPARTSPED := NVL(V_NRSEQALTPARTSPED,0)+1;
       V_DTOPER := SYSDATE;

       BEGIN
            DELETE ALTERAPARTSPED
             WHERE CDCHAVE = 'F'||:OLD.CDFORNECED
               AND CDCAMPO = '09'
               AND DTALTERACAO < V_DTOPER;
       END;

       INSERT INTO ALTERAPARTSPED (NRSEQALTPARTSPED,CDCHAVE,CDCAMPO,DTALTERACAO,DSCONTEUDOANT) 
            VALUES (LPAD(V_NRSEQALTPARTSPED,'10','0'),'F'||:OLD.CDFORNECED,'09',V_DTOPER,:OLD.NRINSCSUFRAMAFO);    
    END IF;
  END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ALTERA_FORNECEDOR_SPED','5.85.000'); END;
/