/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SERC                                                     */
/* Tabela : SERVCONTRAT                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SERC'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SERC
GO

CREATE TRIGGER DTULTATU_SERC
ON SERVCONTRAT
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SERVCONTRAT', null, 'CDCLIENTE=' + CDCLIENTE + ';'+
                                          'CDSERVCONT='+ CDSERVCONT+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SERVCONTRAT
      SET DTULTATUSERC = GETDATE()
      FROM INSERTED;
   END;
END;
GO

