/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PARAMCMPPROD                                             */
/* Tabela : PARAMCMPPROD                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PARAMCMPPROD' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PARAMCMPPROD
GO

CREATE TRIGGER DTULTATU_PARAMCMPPROD
ON PARAMCMPPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PARAMCMPPROD', null, 'CDFILIAL='+  CDFILIAL + ';'+
                                           'CDPRODUTO='+ CDPRODUTO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PARAMCMPPROD
      SET DTULTATUPCOM = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PARAMCMPPROD.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0))    AND
            (ISNULL(PARAMCMPPROD.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))   AND
            (ISNULL(PARAMCMPPROD.IDBLOQNFSAF,0)  = ISNULL(INSERTED.IDBLOQNFSAF,0)) AND
            (ISNULL(PARAMCMPPROD.DTULTATUPCOM,CONVERT(DATETIME,'31/12/1899')) =
                 ISNULL(INSERTED.DTULTATUPCOM,CONVERT(DATETIME,'31/12/1899')));
   END;
END;
GO

